const fs = require('fs');
const srcPath = 'src/';

module.exports = class ResManager {
  static isGroup(group) {
    try {
      if (!fs.statSync(`${srcPath}${group}`).isDirectory()) {
        return false;
      }
      return group.substring(0, 1) !== '_';
    }
    catch (e) {
      return false;
    }
  }

  static getGroups() {
    const groups = [];
    fs.readdirSync(srcPath).forEach((dir) => {
      if (ResManager.isGroup(dir)) {
        groups.push(dir);
      }
    });
    return groups;
  }

  static getGroupResources(group) {
    const resources = [];
    if (!ResManager.isGroup(group)) {
      return null;
    }
    fs.readdirSync(`${srcPath}${group}/`).forEach((resource) => {
      resources.push({
        group,
        resource
      });
    });
    return resources;
  }

  static getAllResources() {
    const resources = [];
    ResManager.getGroups().forEach((group) => {
      ResManager.getGroupResources(group).forEach((resourceData) => {
        resources.push(resourceData);
      });
    });
    return resources;
  }
}
